/*
 *
 *
 */

#include "sim.h"

int loop_push(unsigned short last, unsigned short cond)
{
  int cur;
  if (curdsp.sequencer.loop_stack_len >= 4)
    {
      fprintf(stderr, "loop_push: loop stack overflow\n");
      curdsp.sequencer.sstat |= SSTAT_LOOP_OVERFLOW;
      return -1;
    }
  else if (curdsp.sequencer.sstat & SSTAT_LOOP_EMPTY)
    curdsp.sequencer.sstat ^= SSTAT_LOOP_EMPTY; /* unflag Empty */

  cur = curdsp.sequencer.loop_stack_len;
  curdsp.sequencer.loop_stack[cur].addr = last;
  curdsp.sequencer.loop_stack[cur].cond = cond;
  return ++curdsp.sequencer.loop_stack_len;
}

unsigned int loop_peekaddr(void)
{
  return curdsp.sequencer.loop_stack[curdsp.sequencer.loop_stack_len-1].addr;
}

unsigned int loop_peekcond(void)
{
  return curdsp.sequencer.loop_stack[curdsp.sequencer.loop_stack_len-1].cond;
}

void loop_pop(void)
{
  int cur;
  if (!curdsp.sequencer.loop_stack_len)
    return;
  cur = --curdsp.sequencer.loop_stack_len;
  
  /* i guess the values are just popped into oblivion... */

  curdsp.sequencer.pc = curdsp.sequencer.loop_stack[cur].addr+1;

  curdsp.sequencer.loop_stack[cur].addr = 0x000000;
  curdsp.sequencer.loop_stack[cur].cond = 0x0;
  if (!curdsp.sequencer.loop_stack_len)
    curdsp.sequencer.sstat |= SSTAT_LOOP_EMPTY;
  return;
}

void loop_dump(void)
{
  int i;
  fprintf(stderr, "loop_dump: --- Loop Stack (%2d of 4 filled) ---\n", curdsp.sequencer.loop_stack_len);
  for (i=curdsp.sequencer.loop_stack_len-1;i>=0;i--)
    fprintf(stderr, "loop_dump:\t %2d\t%04x\t%04x\n", 
	    i, 
	    curdsp.sequencer.loop_stack[i].addr,
	    curdsp.sequencer.loop_stack[i].cond);
  fprintf(stderr, "loop_dump: --------------------------------------\n");
  return;
}

void loop_zero(void)
{
  curdsp.sequencer.loop_stack_len = 0;
  memset(curdsp.sequencer.loop_stack, 0x00, sizeof(struct loop_stack_entry_s)*4);
  return;
}
